#!/usr/bin/env python

"""
Conversion functions and data used by XML-RPC and SOAP.

Copyright (C) 2007 Paul Boddie <paul@boddie.org.uk>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option) any
later version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
details.

You should have received a copy of the GNU Lesser General Public License along
with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

converters = {
    "string" : unicode,
    "int" : int,
    "i4" : int,
    "double" : float,
    "boolean" : boolean, # see the module globals
    "dateTime.iso8601" : iso8601, # see the module globals
    "base64" : str
    }

def from_string(typename, value):
    return converters.get(typename, str)(value)

# Utility functions.

def boolean(s):
    if s.lower() == "true":
        return True
    elif s.lower() == "false":
        return False
    else:
        raise ValueError, "String value %s not convertable to boolean." % repr(s)

def iso8601(s):
    # NOTE: To be written.
    return s

# vim: tabstop=4 expandtab shiftwidth=4
